#ifndef RUSIFICATIONWIDGET_H
#define RUSIFICATIONWIDGET_H

#include <QWidget>
#include <QTimer>
#include <QSettings>
#include <QPropertyAnimation>
#include <QPushButton>

namespace Ui {
class RusificationWidget;
}

class PatchDownloader;
class LotroDatManager;

class RusificationWidget : public QWidget
{
    Q_OBJECT

public:
    explicit RusificationWidget(QSettings* settings, PatchDownloader* patch_downloader, LotroDatManager* lotro_dat_manager, QWidget *parent = 0);

    ~RusificationWidget();


private slots:
    void handleContentScrolling(int value);

    void moveMenuHoverWidget(QPushButton* target);

    void scrollContentToWidget(QWidget* widget);

    void on_menuentry_1_clicked();

    void on_menuentry_2_clicked();

    void on_menuentry_3_clicked();

    void on_menuentry_4_clicked();

    void on_menuentry_5_clicked();

private:
    QSettings* app_settings;
    PatchDownloader* patch_updater;
    LotroDatManager* lotro_manager;

    QPushButton* currently_active_entry = nullptr;
    QPropertyAnimation* menuHoverWidgetAnimation = nullptr;
    QPropertyAnimation* scrollAreaContentsAnimation = nullptr;

    Ui::RusificationWidget *ui;
};

#endif // RUSIFICATIONWIDGET_H
